Index: /utils/tools/NESTING/src/agrif_create_data.f90
===================================================================
--- /utils/tools/NESTING/src/agrif_create_data.f90	(revision 10024)
+++ /utils/tools/NESTING/src/agrif_create_data.f90	(revision 10025)
@@ -10,16 +10,16 @@
   !************************************************************************
   ! 									*
-  ! PROGRAM  CREATE_DATA							*
+  ! PROGRAM  CREATE_DATA					        *
   !									*
   ! program to implement data interpolation to generate	 		*
   ! child grid forcing files						*
-  !									*									*
+  !									*
   !Interpolation is carried out using bilinear interpolation		*
   !routine from SCRIP package						*		
   !									*
-  !http://climate.lanl.gov/Software/SCRIP/				*									*
+  !http://climate.lanl.gov/Software/SCRIP/				*
   !************************************************************************
   !
-  INTEGER :: narg,iargc,i
+  INTEGER           :: narg, iargc, ji
   CHARACTER(len=80) :: namelistname
 
@@ -33,40 +33,34 @@
 
   ! read input file (namelist.input)
-  !
   CALL read_namelist(namelistname)
-
-  i = 1
   !
   ! Interpolate U grid  data
-  !
-  DO WHILE( TRIM(U_Files(i)) .NE. '/NULL' )
-     PRINT *,'Grid U forcing files = ',u_files(i)
+  ji = 1
+  DO WHILE( TRIM(U_Files(ji)) .NE. '/NULL' )
+     PRINT *,'Grid U forcing files = ',u_files(ji)
      !        
-     CALL Interp_Extrap_var(U_FILES(i), 'U') 
-     i = i+1                
+     CALL Interp_Extrap_var(U_FILES(ji), 'U') 
+     ji = ji+1                
      !             
   END DO
 
-  i = 1
   !
   ! Interpolate V grid  data
-  !
-  DO WHILE( TRIM(V_Files(i)) .NE. '/NULL' )
-     PRINT *,'Grid V forcing files = ',v_files(i)
+  ji = 1
+  DO WHILE( TRIM(V_Files(ji)) .NE. '/NULL' )
+     PRINT *,'Grid V forcing files = ',v_files(ji)
      !        
-     CALL Interp_Extrap_var(V_FILES(i), 'V') 
-     i = i+1                
+     CALL Interp_Extrap_var(V_FILES(ji), 'V') 
+     ji = ji+1                
      !             
   END DO
-
-  i = 1
   !
   ! Interpolate flux data
-  !
-  DO WHILE( TRIM(Flx_Files(i)) .NE. '/NULL' )
-     PRINT *,'flxfiles = ',flx_files(i)
+  ji = 1
+  DO WHILE( TRIM(Flx_Files(ji)) .NE. '/NULL' )
+     PRINT *,'flxfiles = ',flx_files(ji)
      !        
-     CALL Interp_Extrap_var(FLX_FILES(i), 'T') 
-     i = i+1                
+     CALL Interp_Extrap_var(FLX_FILES(ji), 'T') 
+     ji = ji+1                
      !             
   END DO
Index: /utils/tools/NESTING/src/agrif_create_restart.f90
===================================================================
--- /utils/tools/NESTING/src/agrif_create_restart.f90	(revision 10024)
+++ /utils/tools/NESTING/src/agrif_create_restart.f90	(revision 10025)
@@ -389,5 +389,5 @@
            WRITE(*,*) 'copy time_steps'
            CALL Read_Ncdf_var('time_steps',TRIM(restart_file),tabtemp1DInt) 
-           CALL Write_Ncdf_var('time_steps',TRIM(timedimname),Child_file,tabtemp1DInt)
+           CALL Write_Ncdf_var('time_steps',TRIM(timedimname),Child_file,tabtemp1DInt,'integer')
            CALL Copy_Ncdf_att('time_steps',TRIM(restart_file),Child_file) 
            DEALLOCATE(tabtemp1DInt)
Index: /utils/tools/NESTING/src/agrif_interpolation.f90
===================================================================
--- /utils/tools/NESTING/src/agrif_interpolation.f90	(revision 10024)
+++ /utils/tools/NESTING/src/agrif_interpolation.f90	(revision 10025)
@@ -54,12 +54,13 @@
     ! 
     !
-    CALL agrif_base_interp2(tabin,tabout,imin,jmin,typevar)
-
+    IF( ln_agrif_domain ) THEN
+       CALL agrif_base_interp2(tabin,tabout,imin,jmin,typevar)
+    ELSE
+       CALL agrif_base_interp3(tabin,tabout,imin,jmin,typevar)
+    ENDIF
+    
     !
   END SUBROUTINE agrif_interp
   !
-  !********************************************************
-  !   subroutine agrif_base_interp2			*
-  !********************************************************
   !      
   SUBROUTINE agrif_base_interp2(tabin,tabout,i_min,j_min,typevar)
@@ -189,7 +190,70 @@
   END SUBROUTINE agrif_base_interp2
   !
-  !********************************************************
-  !   subroutine polint					*
-  !********************************************************
+  !      
+  SUBROUTINE agrif_base_interp3(tabin,tabout,i_min,j_min,typevar)
+    !
+    IMPLICIT NONE
+    REAL*8,DIMENSION(:,:) :: tabin,tabout
+    INTEGER :: i_min,j_min
+    CHARACTER(*) :: typevar   
+
+    INTEGER :: nxf,nyf,zx,zy
+    INTEGER :: ji,jj,jif,jjf,jic,jjc,jdecx,jdecy
+    REAL*8 :: Ax, Bx, Ay, By
+
+    nxf = SIZE(tabout,1)
+    nyf = SIZE(tabout,2)
+
+    SELECT CASE(typevar)
+    CASE('T')
+       IF(MOD(irafx,2)==1) THEN ! odd
+          zx = 1 ; zy = 1 ; jdecx = FLOOR(irafx/2.) ; jdecy = FLOOR(irafy/2.)
+       ELSE                     ! even
+          zx = 2 ; zy = 2 ; jdecx = FLOOR(irafx/2.) ; jdecy = FLOOR(irafy/2.)
+       ENDIF
+    CASE('U')
+       IF(MOD(irafx,2)==1) THEN ! odd
+          zx = 1 ; zy = 1 ; jdecx = irafx - 1 ; jdecy = FLOOR(irafy/2.)
+       ELSE                     ! even
+          zx = 1 ; zy = 2 ; jdecx = irafx - 1 ; jdecy = FLOOR(irafy/2.)
+       ENDIF
+    CASE('V')
+       IF(MOD(irafx,2)==1) THEN ! odd
+          zx = 1 ; zy = 1 ; jdecx = FLOOR(irafx/2.) ; jdecy = irafy - 1
+       ELSE                     ! even
+          zx = 2 ; zy = 1 ; jdecx = FLOOR(irafx/2.) ; jdecy = irafy - 1
+       ENDIF
+    CASE('F')
+       IF(MOD(irafx,2)==1) THEN ! odd
+          zx = 1 ; zy = 1 ; jdecx = irafx - 1 ; jdecy = irafy - 1
+       ELSE                     ! even
+          zx = 1 ; zy = 1 ; jdecx = irafx - 1 ; jdecy = irafy - 1
+       ENDIF
+    END SELECT
+
+    
+    DO jj = 1, nyf
+
+       jjf = jj - jdecy
+       jjc = j_min + FLOOR((jjf-1.) / irafy) 
+       
+       DO ji = 1, nxf
+          
+          jif = ji - jdecx 
+          jic = i_min + FLOOR((jif-1.) / irafx) 
+          
+          Bx = MOD( zx*jif-1, zx*irafx ) / REAL(zx*irafx)
+          By = MOD( zy*jjf-1, zy*irafy ) / REAL(zy*irafy)
+          Ax = 1. - Bx
+          Ay = 1. - By
+
+          tabout(ji,jj) = ( Bx * tabin(jic+1,jjc  ) + Ax * tabin(jic,jjc  ) ) * Ay + &
+             &            ( Bx * tabin(jic+1,jjc+1) + Ax * tabin(jic,jjc+1) ) * By
+       END DO
+    END DO
+    
+    !
+  END SUBROUTINE agrif_base_interp3
+
   !       
   SUBROUTINE polint(xin,valin,n,x,val)
@@ -238,7 +302,4 @@
   END SUBROUTINE polint
   !
-  !********************************************************
-  !   subroutine polcoe					*
-  !********************************************************
   !      
   SUBROUTINE polcoe(xin,valin,n,cof)
@@ -709,5 +770,5 @@
           CALL Read_Ncdf_var('time_steps',filename,tabtemp1DInt) 
           !		   print *,'timedeph = ',tabtemp1DInt
-          CALL Write_Ncdf_var('time_steps','time_counter',Child_file,tabtemp1DInt)
+          CALL Write_Ncdf_var('time_steps','time_counter',Child_file,tabtemp1DInt,'integer')
           CALL Copy_Ncdf_att('time_steps',filename,Child_file) 
           DEALLOCATE(tabtemp1DInt)
@@ -984,7 +1045,4 @@
   END SUBROUTINE Interp_Extrap_var
   !
-  !**************************************************************
-  !   end subroutine Interp_var
-  !**************************************************************          
   ! 
 END MODULE agrif_interpolation
Index: /utils/tools/NESTING/src/agrif_partial_steps.f90
===================================================================
--- /utils/tools/NESTING/src/agrif_partial_steps.f90	(revision 10024)
+++ /utils/tools/NESTING/src/agrif_partial_steps.f90	(revision 10025)
@@ -276,6 +276,5 @@
     REAL,DIMENSION(N) :: gdepw,e3t
     REAL :: za0,za1,za2,zsur,zacr,zacr2,zkth,zkth2,zmin,zmax,zdepth
-    INTEGER :: kbathy,jk,diff
-    INTEGER :: bornex,borney,bornex2,borney2
+    INTEGER :: kbathy,jk
     !
     IF ( ( pa0 == 0 .OR. pa1 == 0 .OR. psur == 0 ) &
@@ -348,40 +347,33 @@
        e3t(N) = e3t(N-1)
     END IF
-    !
-    diff = 0      
-    IF ( MOD(irafx,2) .EQ. 0 ) diff = 1
-    !       
-    bornex = nbghostcellsfine + 1 + CEILING(irafx/2.0) + diff - irafx
-    borney = nbghostcellsfine + 1 + CEILING(irafy/2.0) + diff - irafy
-    bornex2 = nxfin - nbghostcellsfine - irafx - CEILING(irafx/2.0) 
-    borney2 = nyfin - nbghostcellsfine - irafy - CEILING(irafy/2.0)                      
-    !
+    !              
     !
     ! west boundary
-    !
-
-    CALL correct_level( gdepwchild,ParentGrid,gdepw,e3t,1,2+nbghostcellsfine+(npt_copy+npt_connect)*irafx-1, &
-         1,nyfin)
-
+    IF( ln_agrif_domain ) THEN
+       CALL correct_level( gdepwchild,ParentGrid,gdepw,e3t,1,2+nbghostcellsfine+(npt_copy+npt_connect)*irafx-1,1,nyfin)
+    ELSE
+       CALL correct_level( gdepwchild,ParentGrid,gdepw,e3t,1,(npt_copy+npt_connect)*irafx,1,nyfin)
+    ENDIF
     !
     ! east boundary
-    !
-
-    CALL correct_level( gdepwchild,ParentGrid,gdepw,e3t,nxfin-1-nbghostcellsfine-((npt_copy+npt_connect)*irafx-1),nxfin, &
-         1,nyfin)
-
+    IF( ln_agrif_domain ) THEN
+       CALL correct_level( gdepwchild,ParentGrid,gdepw,e3t,nxfin-1-nbghostcellsfine-((npt_copy+npt_connect)*irafx-1),nxfin,1,nyfin)
+    ELSE
+       CALL correct_level( gdepwchild,ParentGrid,gdepw,e3t,nxfin-((npt_copy+npt_connect)*irafx+1),nxfin,1,nyfin)
+    ENDIF
     !
     ! north boundary
-    !
-
-    CALL correct_level( gdepwchild,ParentGrid,gdepw,e3t,1,nxfin, &
-         nyfin-1 - nbghostcellsfine -((npt_copy+npt_connect)*irafy-1),nyfin )
-
+    IF( ln_agrif_domain ) THEN
+       CALL correct_level( gdepwchild,ParentGrid,gdepw,e3t,1,nxfin,nyfin-1-nbghostcellsfine-((npt_copy+npt_connect)*irafy-1),nyfin)
+    ELSE
+       CALL correct_level( gdepwchild,ParentGrid,gdepw,e3t,1,nxfin,nyfin-((npt_copy+npt_connect)*irafy+1),nyfin)
+    ENDIF
     !
     ! south boundary
-    !
-    CALL correct_level( gdepwchild,ParentGrid,gdepw,e3t,1,nxfin, &
-         1,2+nbghostcellsfine+(npt_copy+npt_connect)*irafy-1 )
-
+    IF( ln_agrif_domain ) THEN
+       CALL correct_level( gdepwchild,ParentGrid,gdepw,e3t,1,nxfin,1,2+nbghostcellsfine+(npt_copy+npt_connect)*irafy-1)
+    ELSE
+       CALL correct_level( gdepwchild,ParentGrid,gdepw,e3t,1,nxfin,1,(npt_copy+npt_connect)*irafy)
+    ENDIF
     !       
     !
@@ -398,5 +390,5 @@
     INTEGER :: kbathy,jk,indx,indy,diff
     REAL :: xdiff
-    INTEGER :: i,j,ji,ij,ii,jj,jpt,ipt
+    INTEGER :: i,j,ji,ij,ii,jj,jpt,ipt,i1,i2,j1,j2,ii1,ii2,jj1,jj2
     REAL*8 :: slopex, slopey,val,tmp1,tmp2,tmp3,tmp4
     INTEGER :: parentbathy
@@ -471,8 +463,43 @@
     jend = pty + agrif_int((y-ymin-dyfin/2.)/dyfin)               
 
-
-    ALLOCATE(gdepwtemp(ibegin-irafx:iend+irafx,jbegin-irafy:jend+irafy))
-    ALLOCATE(parentbathytab(ibegin-irafx:iend+irafx,jbegin-irafy:jend+irafy))
-
+    IF( ln_agrif_domain ) THEN
+       ALLOCATE(gdepwtemp(ibegin-irafx:iend+irafx,jbegin-irafy:jend+irafy))
+       ALLOCATE(parentbathytab(ibegin-irafx:iend+irafx,jbegin-irafy:jend+irafy))
+
+       i1 = ibegin
+       i2 = iend
+       j1 = jbegin
+       j2 = jend
+       
+       ii1 = -FLOOR(irafx/2.0)+diff
+       ii2 =  FLOOR(irafx/2.0)
+       jj1 = -FLOOR(irafy/2.0)+diff
+       jj2 =  FLOOR(irafy/2.0)
+    ELSE
+       ibegin = minboundx
+       jbegin = minboundy
+       iend   = maxboundx ! (npt_copy+npt_connect)*irafx
+       jend   = maxboundy ! (npt_copy+npt_connect)*irafy
+       !
+       ipbegin = imin + (ibegin-1)/irafx
+       jpbegin = jmin + (jbegin-1)/irafy
+       ipend   = ipbegin + (npt_copy+npt_connect) - 1
+       jpend   = jpbegin + (npt_copy+npt_connect) - 1
+       !
+       i1 = ibegin
+       i2 = iend
+       j1 = jbegin
+       j2 = jend
+       
+       ii1 = 0
+       ii2 = irafx - 1
+       jj1 = 0
+       jj2 = irafy - 1
+       !
+       ALLOCATE(gdepwtemp(ibegin:iend,jbegin:jend))
+       ALLOCATE(parentbathytab(ibegin:iend,jbegin:jend))
+
+    ENDIF
+    
 
     jpt=jpbegin
@@ -482,5 +509,5 @@
 
 
-       DO i=ibegin,iend,irafx
+       DO i=i1,i2,irafx
 
 
@@ -524,6 +551,6 @@
           ! interpolation on fine grid points (connection zone)
           !
-          DO ii = i-FLOOR(irafx/2.0)+diff,i+FLOOR(irafx/2.0)
-             x = ii-i - xdiff/2.
+          DO ii = i+ii1,i+ii2
+!!             x = ii-i - xdiff/2.
 !!             val = parentgrid%gdepw_ps(ipt,jpt)+slopex * x
 !! chanut: uncomment this to get nearest neighbor interpolation
@@ -563,5 +590,5 @@
 
           slopey = vanleer(gdepwtemp(i,j-irafy:j+irafy:irafy))/REAL(irafy)
-
+          
           tmp1 = (maxdepth - gdepwtemp(i,j)) / REAL(irafy)
           tmp2 = (gdepwtemp(i,j) - mindepth) / REAL(irafy)
@@ -583,6 +610,6 @@
 
 
-          DO jj = j-FLOOR(irafy/2.0)+diff,j+FLOOR(irafy/2.0)
-             y = jj-j - xdiff/2.
+          DO jj = j+jj1,j+jj2
+!!             y = jj-j - xdiff/2.
 !!             val = gdepwtemp(i,j) + slopey*y
 !! chanut: uncomment this to get nearest neighbor interpolation
